<?php
/*
Plugin Name: Table2Chart
Plugin URI: http://www.antoniorinaldi.it/from-table-to-chart-in-wordpress/
Description: Draw a chart from a table using HighCharts JS library
Version: 0.1 BETA
Author: Antonio Rinaldi
Author URI: http://www.antoniorinaldi.it
*/

/*
Table2Chart (Wordpress Plugin)
Copyright (C) 2013 Antonio Rinaldi
Contact me at http://www.antoniorinaldi.it/from-table-to-chart-in-wordpress/
This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details. You should have received a copy of the GNU General Public License along with this program.  If not, see <http://www.gnu.org/licenses/>.

IMPORTANT NOTE: The above statement does NOT substitute HighCharts terms of use. HighCharts use is free for a personal or non-profit project under the Creative Commons Attribution-NonCommercial 3.0 License. ANyWAY please refer to HighCharts license page http://shop.highsoft.com/highcharts.html to check the HighCharts precise license conditions.  
*/

T2Cc::setup();

class T2Cc {

public static function initialize() {
DEFINE("T2C_TABLE", "1");
DEFINE("T2C_TYPE", "column");
DEFINE("T2C_TITLE", "");
DEFINE("T2C_SUBTITLE", "");
DEFINE("T2C_TITLEX", "");
DEFINE("T2C_TITLEY", "");
DEFINE("T2C_BACKGROUND", "#ffffff");
DEFINE("T2C_COLOR", "#ff0000,#00ff00,#0000ff,#00ffff,#ff00ff,#ffff00");
DEFINE("T2C_WIDTH", "500");
DEFINE("T2C_HEIGHT", "400");
DEFINE("T2C_ORDER", "column");
DEFINE("T2C_NAMECOL", "1");
DEFINE("T2C_NAMEROW", "1");
DEFINE("T2C_CONVERT", "true");
}

public static function setup() {
self::initialize();
//tell wordpress to register the T2C shortcode
add_shortcode("Table2Chart", array ( __CLASS__,"Table2Chart_handler"));
}
  
public static function Table2Chart_handler($incomingfrompost) {
	wp_enqueue_script("jquery");
	wp_enqueue_script("highcharts", "http://code.highcharts.com/highcharts.js",array("jquery"),null,true);
///
	wp_enqueue_script("Table2Chart", plugins_url( "table2chart.js", __FILE__ ),array("jquery","highcharts"),null,true);
	$incomingfrompost=shortcode_atts(array(
    "table" => T2C_TABLE,
    "type" => T2C_TYPE,
    "title" => T2C_TITLE,
    "subtitle" => T2C_SUBTITLE,
    "titleX" => T2C_TITLEX,
    "titleY" => T2C_TITLEY,
    "background" => T2C_BACKGROUND,
	"color" => T2C_COLOR,
    "width" => T2C_WIDTH,
    "height" => T2C_HEIGHT,          
    "order" => T2C_ORDER,
    "namecol" => T2C_NAMECOL,
    "namerow" => T2C_NAMEROW,
    "convert" => T2C_CONVERT            
  ), $incomingfrompost);
  //run function that actually does the work of the plugin
  $T2C_output = self::Table2Chart_function($incomingfrompost);
  //send back text to replace shortcode in post
  return $T2C_output;
}

public static function Table2Chart_function($incomingfromhandler) {
  //process plugin

  static $T2C_prog;
  $rnd=mt_rand();
  $T2C = "";
  if (! $T2C_prog) $T2C_prog=0; 	
  $T2C_prog++;
  $T2C .="<div id=\"container-HC-" . $T2C_prog . "-" . $rnd . "\" style=\"width:" . esc_attr($incomingfromhandler["width"]) . "px; height:" . esc_attr($incomingfromhandler["height"]) . "px; margin: 0 auto 1em\"></div>\n"; 
  $T2C .="<script type=\"text/javascript\">\njQuery(function () {\nvar container=document.getElementById(\"container-HC-" . $T2C_prog . "-" . $rnd . "\").parentNode;\nvar op={\n";
  $T2C .="table: container.getElementsByTagName('table')[" . esc_attr($incomingfromhandler["table"]-1) . "],\n";
  $T2C .="id: \"container-HC-" . $T2C_prog . "-" . $rnd . "\",\n";
  $T2C .="type: \"" . esc_attr($incomingfromhandler["type"]) . "\",\n";
  $T2C .="title: \"" . esc_attr($incomingfromhandler["title"]) . "\",\n";
  $T2C .="subtitle: \"" . esc_attr($incomingfromhandler["subtitle"]) . "\",\n";
  $T2C .="titleX: \"" . esc_attr($incomingfromhandler["titleX"]) . "\",\n";
  $T2C .="titleY: \"" . esc_attr($incomingfromhandler["titleY"]) . "\",\n";
  $T2C .="color: \"" . esc_attr($incomingfromhandler["color"]) . "\",\n";
  $T2C .="background: \"" . esc_attr($incomingfromhandler["background"]) . "\",\n";
  $T2C .="order: \"" . esc_attr($incomingfromhandler["order"]) . "\",\n";
  $T2C .="namecol: \"" . esc_attr($incomingfromhandler["namecol"]) . "\",\n";
  $T2C .="namerow: \"" . esc_attr($incomingfromhandler["namerow"]) . "\",\n";
  $T2C .="convert: " . ((esc_attr($incomingfromhandler["convert"])=="true") ? "true" : "false") . "\n";
  $T2C .="};\nTable2Chart(op);\n})\n</script>\n";
  //send back text to calling function
  return $T2C;
}

}

?>